function [Sg1,Sg2,Exp1,Exp2,r_2]=Cholesky(f,r,n,Ti,Tf)
eps2 = 1e-5; 


dl = Ti + (Tf - Ti)*[0:n]/n;
Exp1 = f(dl); %mean X_i
Exp2 = (f(dl + eps2)-f(dl))/eps2; %mean X'_i

Sg1 = zeros(n+1); % Cov(X_i,X_j)
Sg2 = Sg1; % Cov(X'_i,X_j)
for i = 1: n+1,
    r_2(i) = (r(dl(i)+eps2,dl(i)+eps2) - 2*r(dl(i)+eps2,dl(i)) + r(dl(i),dl(i)))/eps2^2;
    Sg1(1:i,i)=r(dl(1:i),dl(i));
    Sg2(:,i)= (r(dl+eps2,dl(i)) - r(dl,dl(i)))/eps2;
end
Sg1 = Sg1 + Sg1' - diag(diag(Sg1));
end
